#include <stdio.h>
#include "disp.h"

#include "gr.h"

#define	MODE_CODE	10001

void gr_enummodes(mode_enumerator moden) {
   (moden)(320,200,8,8,8,1,MODE_CODE);
} /* gr_enummodes */

static image*img=0;
int  gr_open(int code) {
   if(code!=MODE_CODE) return 0;
   if(img) { image_free(img); img=0;}
   img=image_alloc(320,200);
   if(!img) return 0;
   disp_init(img);
   return 1;
} /* gr_open */

void gr_close(void) {
   if(img) {
      disp_close();
      image_free(img);
      img=0;
   }
} /* gr_close */

int  gr_key(void) {
   return disp_key();
} /* gr_key */

void gr_redraw(void) {
   disp_redraw();
} /* gr_redraw */

void gr_pack(int x,int y,pix*s,int l) {
   int i,j;
   if(y>=img->ylen) return;
   if(x<0) { l+=x; x=0;}
   if(l<=0) return;
   if(x+l>img->xlen) l=img->xlen-x;
   j=y*img->xlen+x;
   for(i=0;i<l;i++,j++) {
      img->data[j].r=s[i].r;
      img->data[j].g=s[i].g;
      img->data[j].b=s[i].b;
   }
} /* gr_pack */

static char shform[]=SHOT_NAME ".tga";
static int  shnum=0;
int  gr_shot(void) {
   char shname[100];
   do {
      FILE*f;
      sprintf(shname,shform,shnum);
      shnum=(shnum+1)%1000;
      f=fopen(shname,"r"); if(!f) break;
      fclose(f);
   } while(1);
   return image_save(img,shname);
} /* gr_shot */
