#include <stdio.h>
#include <stdlib.h>

#include "image.h"
#include "disp.h"

#define	MAXX	2000

//static char temp[sizeof(RGBA)*MAXX];

static char* readrgba(RGBA *p,char *t,int type) {
    if(type==2) { /* True color */
        p->b=*t++;
        p->g=*t++;
        p->r=*t++;
    } else	/* Any other is mono */
        p->r=p->g=p->b=*t++;
    return t;
} // readrgba

image* image_alloc(int xl,int yl) {
    RGBA*d;image*p;
    if(xl>MAXX) return 0;
    d=(RGBA*)malloc(sizeof(RGBA)*(xl*yl+2*xl));
    if(!d) return 0;
    p=(image*)malloc(sizeof(image));
    if(!p) { free(d); return 0;}
    p->xlen=xl; p->ylen=yl;
    p->temp=(char*)&d[xl*yl];
    p->data=d;
    return p;
} // image_alloc

image* image_load(char *tganame) {
    FILE *f=fopen(tganame,"rb");
    int xl,yl,typ,x,y,psz;
    image*p=0; RGBA*d; char *t;
    if(!f) goto _return;
    fseek(f,2L,SEEK_SET);
    typ=getc(f);
    if(typ==2) psz=3; else psz=1;
    fseek(f,12L,SEEK_SET);
    xl=fgetc(f); xl+=fgetc(f)<<8;
    if(xl>MAXX) goto _return;
    yl=fgetc(f); yl+=fgetc(f)<<8;
    p=(image*)malloc(sizeof(image));
    if(!p) goto _return;
    fgetc(f); fgetc(f);
    p->xlen=xl; p->ylen=yl;
    d=(RGBA*)malloc(xl*yl*sizeof(RGBA)+(xl*2*psz));
    if(!d) { free(p); p=0; goto _return;}
    p->data=d;
    p->temp=(char*)&d[xl*yl];
    for(y=0; y<yl; y++) {
        t=p->temp;
        fread(t,1,xl*psz,f);
        d=&p->data[(yl-1-y)*xl];
        for(x=0;x<xl;x++,d++) t=readrgba(d,t,typ);
        printf("."); fflush(stdout);
    }
_return:;
    if(f) fclose(f);
    return p;
} // image_load

void image_free(image*p) {
    if(p) {
        if(p->data) free(p->data);
        free(p);
    }
} // image_Free

#if	0
void image_disp(int bmpn,image *p) {
    int i;
    disp_setbmp(bmpn);
    for(i=0;i<p->ylen;i++) {
//if(i==127) _asm { int 3}
        disp_setrow(i);
        disp_copyrow(&p->data[i*p->xlen]);
    }
} // image_disp
#endif

int image_save(image*p,char *fn) {
   FILE*f;
   int x,y;
   f=fopen(fn,"wb");
   if(!f) return 0;
   putc(0,f); putc(0,f);
   putc(2,f); putc(0,f);
   putc(0,f); putc(0,f); putc(0,f); putc(0,f);
   putc(0,f); putc(0,f); putc(0,f); putc(0,f);
   putc(p->xlen,f); putc(p->xlen>>8,f);
   putc(p->ylen,f); putc(p->ylen>>8,f);
   putc(0x18,f); putc(0,f);	/* Done header */
   for(y=p->ylen-1;y>=0;y--) {
      RGBA *t=&p->data[y*p->xlen];
      for(x=0;x<p->xlen;x++) {
         putc(t[x].b,f);
         putc(t[x].g,f);
         putc(t[x].r,f);
      }
   }
   return 1;
} /* image_save */
