#include "obj.h"

static longint stx,sty,stz;
static longint xlen,ylen,zlen;

void obj_setcoord(longint x,longint y,longint z) {
   stx=x; sty=y; stz=z;
} /* obj_setcoord */

void obj_setsize(longint sx,longint sy,longint sz) {
   xlen=sx; ylen=sy; zlen=sz;
} /* obj_setsize */

static colorinfo colors[N_SIDES];
static transpinfo transps[N_DIMS];
static char isoflag=0;
static int add_atom(longint x,longint y,longint z) {
   if(isoflag) return oct_addatom(x,y,z,colors,transps[0]);
   else return 0;
} /* add_atom */
void obj_setisocolor(colorinfo*color,transpinfo transp) {
   isoflag=1;
   colors[0]=*color; transps[0]=transp;
} /* obj_setisocolor */

int  create_bar(void) {
   longint x,y,z;
   for(z=0;z<zlen;z++) {
      for(y=0;y<ylen;y++) {
         for(x=0;x<xlen;x++) {
            if(!add_atom(x+stx,y+sty,z+stz)) return 0;
         }
      }
   }
   return 1;
} /* create_bar */

int  create_sphere(void) {
   longint x,y,z,l=xlen;
   double rz,ry,rx,rsq=l*l;
   for(z=-l;z<=l;z++) {
      rz=z*z;
      if(rz>rsq) continue;
      for(y=-l;y<=l;y++) {
         ry=y*y+rz; if(ry>rsq) continue;
         for(x=-l;x<=l;x++) {
            rx=x*x+ry;
            if(rx<=rsq) {
               if(!add_atom(x+stx,y+sty,z+stz)) return 0;
            }
         }
      }
   }
//   oct_optimize();
   return 1;
} /* create_sphere */

#define	_abs(x) ((x)<0?-(x):(x))
int  line3d(longint x,longint y,longint z,
            longint xe,longint ye,longint ze,
            int isoflag,
            colorinfo*color,transpinfo transp
           ) {
   longint xer,yer,zer;
   longint i,err;
   xer=xe-x; yer=ye-y; zer=ze-z;
   err=_abs(xer); if(err<_abs(yer)) err=_abs(yer); if(err<_abs(zer)) err=_abs(zer);
   if(err<1) err=1;
   for(i=0;i<err;i++) {
      longint xx=x+(xer*i)/err,yy=y+(yer*i)/err,zz=z+(zer*i)/err;
      if(isoflag) { if(!oct_addatom(xx,yy,zz,color,transp)) return 0;
      } else return 0;
   }
   return 1;
} /* line3d */

int create_grass(void) {
} /* create_grass */

int create_flame(void) {
} /* create_flame */
