#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include "gr.h"

#include "cam.h"
#include "vox.h"

int width=0,height=0,mode=-1;
#pragma	argsused
static int enumerator(int wid,int hig,int rbits,int gbits,int bbits,
		       int pages,int code) {
   int remember=0;
   if(width<wid) {
      remember=1;
   } else if(width==wid) { remember=1;}
   if(remember) {
      width=wid; height=hig; mode=code;
   }
   return 1;
} /* enumerator */

void add_test_voxel(colorinfo *color,transpinfo transp,
                    double x,double y,double z,double size) {
   voxinfo vi;
   vi.color=*color; vi.transp=transp;
   vi.coord[X_DIM]=x; vi.coord[Y_DIM]=y; vi.coord[Z_DIM]=z;
   vi.size=size;
   vox_check(&vi,1);
   if(!vi.invisible) vox_add(&vi);
} /* add_test_voxels */
static colorinfo purered={MAXCOLORCOMP,0,0},
                 puregreen={0,MAXCOLORCOMP,0},
                 pureblue={0,0,MAXCOLORCOMP},
                 purewhite={MAXCOLORCOMP,MAXCOLORCOMP,MAXCOLORCOMP};
void add_test_voxels(void) {
   int t=TRANSPFULL*3/4;
   add_test_voxel(&purered,t,-200,0,0,50);
   add_test_voxel(&puregreen,t,-100,0,0,50);
   add_test_voxel(&pureblue,t,100,0,0,50);
   add_test_voxel(&purewhite,t,200,0,0,50);
} /* add_test_voxels */
void draw_test_scene(void) {
   dvec3 pos,fwd,up;
   cam_getview(&pos,&fwd,&up);
   vox_view(&pos,&fwd,&up);
   vox_reset();
   add_test_voxels();
   vox_draw();
cprintf("%lf,%lf,%lf\r",pos[0],pos[1],pos[2]);
   gr_redraw();
} /* draw_test_scene */

#define	ROTSPEED	(TWOPI/300)
void test_drawing(void) {
   int done=0,k,speed=0;
   while(!done) {
      cam_move(speed);
      draw_test_scene();
      do {
         k=gr_key();
         switch(k) {
            case 0x1b:
            case '`': case '~': done=1; break;
            case '+': speed++; break;
            case '-': speed--; break;
            case '/': speed=0; break;
            case 's': case 'S': cam_rotate(0, ROTSPEED,0); break;
            case 'f': case 'F': cam_rotate(0,-ROTSPEED,0); break;
            case 'e': case 'E': cam_rotate( ROTSPEED,0,0); break;
            case 'd': case 'D': cam_rotate(-ROTSPEED,0,0); break;
            default: break;
         }
      } while(k);
   }
} /* test_drawing */

void main(void) {
   gr_enummodes(&enumerator);
   if(mode<0) { printf("No graphic modes!\n"); exit(1); }
   if(!vox_init(120,width,height)) { printf("Error initializing renderer!\n"); exit(1);}
   cam_init(1000,0,0);
   cam_rotate(0,TWOPI/4,0);
   gr_open(mode);
   test_drawing();
   vox_done();
   gr_close();
   exit(0);
} /* main */
