#ifndef	_vox_h
#define	_vox_h

#include "gr.h"
#include "hier.h"

#define	V_MEANINGLESS(transp) ((transp)==TRANSPNONE)

typedef	struct	_scrbox	{
   short int left,right,up,down;
} scrbox;
typedef	struct	_voxinfo	{
   ldvec3 coord;	/* center coords */
   longint size;	/* Side size */
   colorinfo color;	/* Selfexplanatory */
   transpinfo transp;	/* Selfexplanatory */
/* Set by vox_check: */
   short int invisible;	/* Invisible at all */
   short int split;		/* split by at least one view frustrum planes - subdivide */
   double scrsize;	/* Size on screen. If negative - reject */
   scrbox scrc;	/* Box coordinates */
   double z;	/* z coordinate */
} voxinfo;

extern double _vox_z_one;	/* z coord for 1:1 persp scale */
int  vox_init(int fov_ang,int maxx,int maxy);			/* Initialize voxels engine */
void vox_done(void);				/* Free up used memory */

void vox_view(dvec3*viewp,dvec3 *forward,dvec3 *up);	/* View direction. Should be set before vox_reset. */
void vox_reset(void);				/* Reset all lists */
void vox_check(voxinfo *info,int checksplit);
#define	VA_SUCCESS	1
#define	VA_PARTIAL	2	/* Flag to further subdivide voxel */
int  vox_add(voxinfo*vi);	/* Add voxel into list */

void vox_draw(void);	/* Draw voxels */

#endif	/* _vox_h */
